<?
   $cli_id = 40623;
	$tag_kategorie = 32728;
	$squeeze_kategorie = 16510;
	$send_timeout = 3;
	
	
	//***************************************************************************
	
	$debug = true;
	$logging = true;
	
	$p1_mac = "00:04:20:1e:92:31";
	$p2_mac = "00:04:20:27:b7:04";
	$p3_mac = "00:04:20:27:ae:ac";
	$p4_mac = "";
	$p5_mac = "";

	$mac_adressen = array(
						"00:04:20:1e:92:31",
						"00:04:20:27:b7:04",
						"00:04:20:27:ae:ac",
						"00:00:00:00:00:00",
						"00:00:00:00:00:00",
						"00:00:00:00:00:00",
						"00:00:00:00:00:00",
						"00:00:00:00:00:00",
						"00:00:00:00:00:00",
						"00:00:00:00:00:00" );

	//***************************************************************************
	if ( !isset($IPS_VALUE)) $IPS_VALUE = "version 1007";
	
	if ( $IPS_SENDER == "Execute" ) ;
	
	//IPS_LogMessage("LOG" ,$IPS_SENDER);

	if ( $IPS_SENDER == "RegisterVariable" )
	   {

 		$input = urldecode(rtrim( $IPS_VALUE ));
 	
 		$teile = explode("\n", $input);
 		foreach($teile as $zeile)
 	      	do_zeile($zeile);
 	
		}

//******************************************************************************
// Kommando an Server senden und warte auf Antwort bis Timeout
//******************************************************************************
function send($clear,$command)
	{
	
	global $cli_id;
	global $debug;
	global $logging;
	global $send_timeout;
	
	clear($clear);

	if ( $logging ) logging("->",$command);
	
	$command = $command . chr(10);
	CSCK_SendText($cli_id,$command);

	$return = wait($clear);

	return $return;
	}


//******************************************************************************
// Hier werden alle Zeilen die von der Squeezebox kommen ausgewertet
// Bei Antwort die keine Daten enthalten ( zB stop ) dummy anhaengen
// wegen Timeouterkennung
//******************************************************************************
function do_zeile($input)
	{

	global $debug;
	global $logging;
	global $squeeze_kategorie;
	global $tag_kategorie;
	global $p1_mac;
	global $p2_mac;
	global $p3_mac;
	global $p4_mac;
	global $p5_mac;
	global $logging;
	global $debug;
	global $mac_adressen;
	

	if ( $logging ) logging("<-",$input);

   SetValueString(IPS_GetObjectIDByName("answer",$squeeze_kategorie),$input);

	$answer = "answer_unknown";
	$dummy = false;
	
	for ( $x=0;$x<count($mac_adressen);$x++)
	   {
		$name = "$mac_adressen[$x] time"; 	if ( check_answer($name,$input) ) { $answer = $name;  }
   	$name = "$mac_adressen[$x] stop"; 	if ( check_answer($name,$input) ) { $answer = $name; $dummy = true; }
   	$name = "$mac_adressen[$x] pause"; 	if ( check_answer($name,$input) ) { $answer = $name; $dummy = true; }
   	$name = "$mac_adressen[$x] name"; 	if ( check_answer($name,$input) ) { $answer = $name;  }
   	$name = "$mac_adressen[$x] playlist save"; 	if ( check_answer($name,$input) ) { $answer = $name;  }
   	$name = "$mac_adressen[$x] playlist load"; 	if ( check_answer($name,$input) ) { $answer = $name;  }
   	$name = "$mac_adressen[$x] playlist newsong"; 	if ( check_answer($name,$input) ) { $answer = $name;  }
   	$name = "$mac_adressen[$x] playlist play"; 	if ( check_answer($name,$input) ) { $answer = $name;  }
   	$name = "$mac_adressen[$x] playlist duration 0"; 	if ( check_answer($name,$input) ) { $answer = $name;  }
   	$name = "$mac_adressen[$x] mode"; 	if ( check_answer($name,$input) ) { $answer = $name;  }

	   }
	
   

   $name = "player count"; 	if ( check_answer($name,$input) ) { $answer = $name;  }

   //$name = "player id 0"; 		if ( check_answer($name,$input) ) { $answer = $name;  }

   $name = "listen"; 			if ( check_answer($name,$input) ) { $answer = $name;  }
   $name = "version";      	if ( check_answer($name,$input) ) { $answer = $name;  }


	if ( $answer == "answer_unknown" )
		$id = IPS_GetObjectIDByName($answer,$squeeze_kategorie);
	else
		$id = IPS_GetObjectIDByName($answer,$tag_kategorie);

	if ( !$id )
	   {
		if ( $debug ) echo "Create: $answer";
		$id = IPS_CreateVariable(3);
		IPS_SetParent($id,$tag_kategorie);
      IPS_SetName($id,$answer);
		}

	if ( $answer != "answer_unknown" )
		$input = trim(substr($input,strlen($answer)));
	
	if ( $dummy )
	   $input = $input . "OK";
	SetValueString($id,$input);


	}
	
function check_answer($name,$input)
	{
	global $debug;
	
	$return = false;
	
	if ( substr($input,0,strlen($name)) == $name )
		{
		if ( $debug )
			echo "[$name][$input]";
		$return = true; 
		}
		
	return $return;
	
	}

function get_tag($tag)
	{
	global $debug;
	global $tag_kategorie;
	$data = false;
	
	$id = IPS_GetObjectIDByName($tag,$tag_kategorie);
	
	if ( $debug ) echo $id;
	if ( $id ) $data = GetValueString($id);
	if ( $data ) { $data = trim(substr($data,strlen($tag))); }
	
	return $data;
	}

function squeeze_command()
	{
	global $p1_mac;
	global $p2_mac;
	global $p3_mac;
	global $p4_mac;
	global $p5_mac;
	global $mac_adressen;
	
	global $debug;
	
	$anzahl_arg = func_num_args();
	if ( $anzahl_arg == 0 ) return;
	if ( $anzahl_arg > 0 ) $cmd = func_get_arg(0);
	if ( $anzahl_arg > 1 ) $p1  = func_get_arg(1);
	if ( $anzahl_arg > 2 ) $p2  = func_get_arg(2);
	if ( $anzahl_arg > 3 ) $p2  = func_get_arg(3);
	if ( $anzahl_arg > 4 ) $p2  = func_get_arg(4);

   $return = false;
   
	switch ( $cmd)
	   {
	   case "VERSION" 			:  $return = send("version","version ?"); 			break;
	   case "LISTEN"  			:  $return = send("listen","listen $p1"); 			break;
	   case "PLAYERCOUNT"  		:  $return = send("player count","player count ?"); 	break;

	   case "PLAYERGETNAME"		:  $return = send("$mac_adressen[$p1] name","$mac_adressen[$p1] name ?"); 	break;

	   case "PLAYERGETTIME" 	:  $return = send("$mac_adressen[$p1] time","$mac_adressen[$p1] time ?"); 	break;

	   case "PLAYERLOADLIST" 	:  $return = send("$mac_adressen[$p1] playlist load","$mac_adressen[$p1] playlist load $p2"); 	break;

	   case "PLAYERPAUSE" 		:  $return = send("$mac_adressen[$p1] pause","$mac_adressen[$p1] pause"); 	break;

	   case "PLAYERSAVELIST" 	:  $return = send("$mac_adressen[$p1] playlist save","$mac_adressen[$p1] playlist save $p2"); 	break;

	   case "PLAYERSETTIME" 	:  $return = send("$mac_adressen[$p1] time","$mac_adressen[$p1] time $p2"); 	break;

	   case "PLAYERSTOP" 		:  $return = send("$mac_adressen[$p1] stop","$mac_adressen[$p1] stop"); 	break;

	   case "PLAYERPLAY" 		:  $return = send("$mac_adressen[$p1] playlist play","$mac_adressen[$p1] playlist play $p2"); 	break;

	   case "PLAYERDURATION" 	:  $return = send("$mac_adressen[$p1] playlist duration $p2","$mac_adressen[$p1] playlist duration $p2 ?"); 	break;

	   case "PLAYERMODE" 		:  $return = send("$mac_adressen[$p1] mode","$mac_adressen[$p1] mode ?"); 	break;

	   default : echo "Unknown CMD : .$cmd" ;break;
	   }
	
   return $return;

	}

function clear($tag)
	{
	global $tag_kategorie;
	$id = false;
	$id = IPS_GetObjectIDByName($tag,$tag_kategorie);
	if ( $id ) SetValueString($id,"");
	}



function wait($tag)
	{
	global $tag_kategorie;
	global $send_timeout;
	
	$id = false;
	$return = false;
	
	$id = IPS_GetObjectIDByName($tag,$tag_kategorie);

	if ( $id )
		{
		$start_sec = time();
		$timeout_sec = $start_sec + $send_timeout;
		$laufzeit = 0;
		while (time() <= $timeout_sec)
		   {
		   
		   usleep(10);
		   $laufzeit = $laufzeit + 10 ;
		   if ( GetValueString($id) != "" )
				{
				$return = GetValueString($id);
				break;
				}
		   }

		logging("--",$laufzeit);
	
		
		}

	return $return;
	
	}

function logging($p1,$text)
	{

	$logdatei = IPS_GetKernelDir() . "logs\\squeeze.log";
	$datei = fopen($logdatei,"a+");
	fwrite($datei, date("d.m.Y H:i:s").$p1 . $text . chr(13));
	fclose($datei);

	
	}
	
	
?>